\documentclass[convert = false]{standalone}

% Necessary includes.
\usepackage{tikz}
\usetikzlibrary{arrows}
\usetikzlibrary{calc}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{positioning}
\usetikzlibrary{decorations.markings}

% Definition of some variables.
\def\OmegaLength{4cm}
\def\OmegaSkip{1cm}
\def\OmegaHeight{1.8cm}

\def\GammaXA{\OmegaSkip/2+\OmegaLength/4}
\def\GammaXB{\OmegaSkip/2+\OmegaLength-\OmegaLength/4-2mm}
\def\GammaR{\OmegaHeight/4}

\def\TubeSkip{\OmegaHeight/2+0.4cm}
\def\TubeHeight{1.1cm}

\def\GSkip{\OmegaHeight+\TubeSkip+\TubeHeight/2+0.5cm}
\def\GXA{\GammaXA-2mm}
\def\GXB{\GammaXB-1mm}

\definecolor{GammaColor}{RGB}{60, 60, 60}
\definecolor{tubecolor}{RGB}{5, 65, 185}
%~ \definecolor{Gcolor}{RGB}{230, 46, 0}
%~ \definecolor{Gcolor}{RGB}{255, 128, 0}
\definecolor{Gcolor}{RGB}{47,68,110}
\definecolor{emphColor}{RGB}{230, 46, 0}


% Fading attribute. Confer https://tex.stackexchange.com/questions/141378/path-following-color-gradient-in-tikz
\tikzset{fader/.style n args={3}{
    postaction={
    decorate,
    decoration={
    markings,
    mark=between positions 0 and \pgfdecoratedpathlength step 0.05pt with {
    \pgfmathsetmacro\myval{multiply(
        divide(
        \pgfkeysvalueof{/pgf/decoration/mark info/distance from start}, \pgfdecoratedpathlength
        ),
        100
    )};
    \pgfsetfillcolor{#3!\myval!#2};
    \pgfpathcircle{\pgfpointorigin}{#1};
    \pgfusepath{fill};}
}}}}

%~ \tikzset{fader/.style={
    %~ postaction={
        %~ decorate,
        %~ decoration={
            %~ markings,
            %~ mark=at position \pgfdecoratedpathlength-0.5pt with {\arrow[blue,line width=#1] {>}; },
            %~ mark=between positions 0 and \pgfdecoratedpathlength-8pt step 0.5pt with {
                %~ \pgfmathsetmacro\myval{multiply(divide(
                    %~ \pgfkeysvalueof{/pgf/decoration/mark info/distance from start}, \pgfdecoratedpathlength),100)};
                %~ \pgfsetfillcolor{blue!\myval!red};
                %~ \pgfpathcircle{\pgfpointorigin}{#1};
                %~ \pgfusepath{fill};}
%~ }}}}

\begin{document}
\begin{tikzpicture}

% Define some coordinates.
\coordinate (OmegaCenter) at (\OmegaLength/2+\OmegaSkip/2,\OmegaHeight/2);
\coordinate (GammaACenter) at (\GammaXA,\OmegaHeight/2+1.5mm);
\coordinate (GammaBCenter) at (\GammaXB,\OmegaHeight/2+1.5mm);
\coordinate (TubeCenter) at (OmegaCenter)+(0,2cm);
\coordinate (GACenter) at (\GXA,\GSkip);
\coordinate (GBCenter) at (\GXB,\GSkip-1mm);

% Omega rectangle.
\node[trapezium, fill=gray!25, minimum height=\OmegaHeight, minimum width=\OmegaLength+\OmegaSkip, trapezium left angle=70, trapezium right angle=110, trapezium stretches=true] (Omega) at (OmegaCenter) {};
\node[shift=(Omega.bottom right corner),xshift=\OmegaSkip/1.6,yshift=3mm,color=GammaColor] {$\Omega$};

% Gamma(p0)
\draw[fill=white,draw=black, semithick] (GammaACenter) circle [x radius=\GammaR, y radius=\GammaR/2, rotate=45] node (GammaA) {};
\node[shift=(GammaA.east),xshift=1.3*\GammaR,yshift=0.8*\GammaR,color=GammaColor] {\tiny $\Gamma(\textbf{p}^0)$};
\draw[shift=(GammaA.south),xshift=-3mm,yshift=-2mm, color=emphColor] plot[mark=*] coordinates{(0,0)} node (X) {} node[xshift=-2mm,yshift=-2.5mm] {$x$};

% Gamma(p)
\draw[name=GammaB,fill=white,draw=black, semithick] (GammaBCenter) circle [x radius=\GammaR, y radius=\GammaR/2.5, rotate=110] node (GammaB) {};
\node[shift=(GammaB.east),xshift=0.5*\GammaR,yshift=0.8*\GammaR,color=GammaColor] {\tiny $\Gamma(\textbf{p})$};
\draw[shift=(GammaB.south),xshift=-1mm,yshift=-1mm,color=emphColor] plot[mark=*] coordinates{(0,0)} node (PsiX){} node[xshift=3mm,yshift=-3.2mm] {\footnotesize$\psi(\textbf{p};x)$};

% Psi function.
\draw[->,>=stealth,out=-10,in=200,thick,color=emphColor] (X.south east) to node[midway,below] {\footnotesize $\psi(\textbf{p})$} (PsiX.south west);

% Draw tube.
\node[cylinder, minimum width=\TubeHeight,minimum height=\OmegaLength+\OmegaSkip/2-5mm, above = \TubeSkip of Omega, aspect=2.0, cylinder uses custom fill, cylinder end fill=tubecolor!20, cylinder body fill=tubecolor!50] (Tube) at (TubeCenter) {};
\node[shift=(Tube.after top),xshift=\OmegaSkip/1.6,yshift=2mm,color=tubecolor!110!white!200] {$\mathcal{M}_0$};

% Draw points on tube and arcs connecting to Omega.
\draw[shift=(Tube.center),xshift=-8mm,yshift=2mm,color=tubecolor!110!white!200] plot[mark=*] coordinates{(0,0)} node (PhiX){};
\draw[->,>=stealth,out=110,in=220,thick] (X.north west) to node[midway,left] {\footnotesize $\varphi$} (PhiX.south west);

\draw[shift=(Tube.center),xshift=8mm,yshift=2mm,color=tubecolor!110!white!200] plot[mark=*] coordinates{(0,0)} node (PhiPsiX){};
\draw[->,>=stealth,out=220,in=110,thick] (PhiPsiX.south west) to node[midway,right] {\footnotesize $\varphi^{-1}$} (PsiX.north west);

% Omega G(p)'s
\color{Gcolor}
\draw[thick] (GACenter) circle [x radius=\GammaR, y radius=\GammaR/2.4, rotate=25] node (GA) {};
\draw[shift=(GA.south),xshift=1mm,yshift=-0.5mm] plot[mark=*] coordinates{(0,0)} node (GAX) {};
\node[shift=(GA.west),xshift=-3.2mm,yshift=2.5mm] {\tiny $\mathcal{G}(\textbf{p}^{0})$};
%~ \draw[thick,out=270,in=30,fader={0.4pt}{Gcolor}{white}] ($(GAX) + (-5.15mm,0.2mm)$) to ($(GAX) + (-10mm,-5mm)$);
\draw[thick,out=270,in=30,fader={0.41pt}{Gcolor}{white}] ($(GAX) + (-5.15mm,0.2mm)$) to ($(GAX) + (-10mm,-5mm)$);
\draw[thick,out=-30,in=200,fader={0.41pt}{Gcolor}{white}] ($(GAX) + (2.85mm,4mm)$) to ($(GAX) + (10mm,4mm)$);

\draw[thick] (GBCenter) circle [x radius=\GammaR, y radius=\GammaR/2.5, rotate=160] node (GB) {};
\draw[shift=(GB.south),xshift=-1mm,yshift=-0.2mm] plot[mark=*] coordinates{(0,0)} node (GBX) {};
\node[shift=(GB.east),xshift=3mm,yshift=2.5mm] {\tiny $\mathcal{G}(\textbf{p})$};
\draw[thick,out=230,in=-10,fader={0.41pt}{Gcolor}{white}] ($(GBX) + (-3.2mm,3.15mm)$) to ($(GBX) + (-10mm,1.5mm)$);
\draw[thick,out=-100,in=160,fader={0.41pt}{Gcolor}{white}] ($(GBX) + (5.275mm,0.25mm)$) to ($(GBX) + (10mm,-5mm)$);

% Draw points connecting tube from/to Gamma(p)'s
\color{black}
\draw[->,>=stealth,thick] (PhiX) to node[midway,right] {\scriptsize $\raisebox{-0.25pt}{$\amalg$}(\textbf{p}^0)$} (GAX);
\draw[->,>=stealth,thick] (GBX) to node[midway,right] {\footnotesize $\pi$} (PhiPsiX);

\draw[->,>=stealth,thick,out=20,in=150] ($(GA.north east) + (3mm,2mm)$) to node[midway,above,yshift=-1mm] {\scriptsize $\Psi(\textbf{p}) \circ \Psi(\textbf{p}^0)^{-1}$} ($(GB.north) + (-3mm,1.5mm)$);

\end{tikzpicture}
\end{document}
